## qhull 2012.1

=== CMakeLists.txt ===
# CMakeLists.txt -- CMake configuration file for qhull, qhull6, and related programs
#
# To build with MSYS/mingw
#   cd build && cmake -G "MSYS Makefiles" .. && cmake ..
#   make
#   make install
#
# To uninstall on unix or MSYS/mingw
#   xargs rm <build/install_manifest.txt
#
# To build Qhull Visual Studio projects, run cmake twice
#   mkdir -p build-cmake && cd build-cmake && cmake -G "Visual Studio 8 2005" .. && cmake ..
#   Double click build-cmake/qhull-all.sln
#   Build INSTALL for C:/Program Files/qhull
#   You may need to copy bin/msvcr80.dll into C:/Program Files/qhull/bin
#   If using library debug targets, please rename with '_d' (e.g., qhullstatic_d.lib)
#
# To uninstall on Windows
#   Delete C:/Program Files/qhull
#
# For qhulltest, use the Qt build (src/qhull-all.pro)
#
# Qhull ships with cmake-derived sln and proj files
#   See eg/make-vcproj.sh -- it created the first versions of these files
#   Change to relative paths
#   Remove ZERO_CHECK, ALL_BUILD, and INSTALL projects
#   Change targets to bin/ and lib/ directories
#   Disable incremental linking and ilk files (LinkIncremental="1")
#   Disable Run-Time Type Info (rtti)
#   Remove src/libqhullcpp from most of the AdditionalIncludeDirectories
#   Remove CMAKE_INTDIR from PreprocessorDefinitions
#   Adjust target names and destinations (e.g., lib/libqhullstatic_d.a)
#  
# $Id: //main/2011/qhull/CMakeLists.txt#23 $$Change: 1494 $
# $DateTime: 2012/02/21 22:41:40 $$Author: bbarber $

project(qhull)
cmake_minimum_required(VERSION 2.6)

# Define qhull_VERSION in CMakeLists.txt, Makefile, qhull-exports.def, qhull_p-exports.def, and qhull-warn.pri
string(REGEX REPLACE ".* ([0-9]+) .*"
    "6.3.1.\\1"  qhull_VERSION "$Change: 1494 $")
# qhull_SOVERSION: 2003 = empty, 2009 = 5 , 2010-2012 = 6
set(qhull_SOVERSION 6)
set(qhull_VERSION2 "2012.1 2012/02/18")

if(INCLUDE_INSTALL_DIR)
else()
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include)
endif()
if(LIB_INSTALL_DIR)
else()
set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib)
endif()
if(BIN_INSTALL_DIR)
else()
set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
endif()
if(MAN_INSTALL_DIR)
else()
    if(WIN32)
        set(MAN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/man/man1)
    else()
        set(MAN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/man/man1)
    endif()
endif()
if(DOC_INSTALL_DIR)
else()
    if(WIN32)
        set(DOC_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/doc)
    else()
        set(DOC_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/qhull)
    endif()
endif()
message(STATUS)
message(STATUS "========== qhull Build Information ==========")
message(STATUS "Build Version: 				   ${qhull_VERSION}")
message(STATUS "Install Prefix (CMAKE_INSTALL_PREFIX):     ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Binary Directory (BIN_INSTALL_DIR):        ${BIN_INSTALL_DIR}")
message(STATUS "Library Directory (LIB_INSTALL_DIR):       ${LIB_INSTALL_DIR}")
message(STATUS "Include Directory (INCLUDE_INSTALL_DIR):   ${INCLUDE_INSTALL_DIR}")
message(STATUS "Documentation Directory (DOC_INSTALL_DIR): ${DOC_INSTALL_DIR}")
message(STATUS "Man Pages Directory (MAN_INSTALL_DIR):     ${MAN_INSTALL_DIR}")
message(STATUS "Build Type (CMAKE_BUILD_TYPE):             ${CMAKE_BUILD_TYPE}")
message(STATUS "To override these options, add -D{OPTION_NAME}=... to the cmake command")
message(STATUS "  Build the debug targets                  -DCMAKE_BUILD_TYPE=Debug")
message(STATUS)
message(STATUS "To build and install qhull, enter \"make\" and \"make install\"")
message(STATUS)

# ---------------------------------------
# Define library source files and variables
#
# Files for individual targets are defined with the target
# ---------------------------------------

# Order libqhull object files by frequency of execution.  Small files at end.
set(
    libqhull_HEADERS
        src/libqhull/libqhull.h
        src/libqhull/geom.h
        src/libqhull/io.h
        src/libqhull/mem.h
        src/libqhull/merge.h
        src/libqhull/poly.h
        src/libqhull/qhull_a.h
        src/libqhull/qset.h
        src/libqhull/random.h
        src/libqhull/stat.h
        src/libqhull/user.h
)
set(
    libqhull_SOURCES
        src/libqhull/global.c
        src/libqhull/stat.c
        src/libqhull/geom2.c
        src/libqhull/poly2.c
        src/libqhull/merge.c
        src/libqhull/libqhull.c
        src/libqhull/geom.c
        src/libqhull/poly.c
        src/libqhull/qset.c
        src/libqhull/mem.c
        src/libqhull/random.c
        src/libqhull/usermem.c
        src/libqhull/userprintf.c
        src/libqhull/io.c
        src/libqhull/user.c
        src/libqhull/rboxlib.c
        src/libqhull/userprintf_rbox.c
        ${libqhull_HEADERS}
)

set(
    libqhull_DOC
        src/libqhull/index.htm
        src/libqhull/qh-geom.htm
        src/libqhull/qh-globa.htm
        src/libqhull/qh-io.htm
        src/libqhull/qh-mem.htm
        src/libqhull/qh-merge.htm
        src/libqhull/qh-poly.htm
        src/libqhull/qh-qhull.htm
        src/libqhull/qh-set.htm
        src/libqhull/qh-stat.htm
        src/libqhull/qh-user.htm    
)

set(
    testqset_HEADERS
        src/libqhull/mem.h
        src/libqhull/qset.h
)
set(
    testqset_SOURCES
        src/libqhull/qset.c
        src/libqhull/mem.c
        src/testqset/testqset.c
        ${testqset_HEADERS}
)

set(
    libqhullcpp_HEADERS
        src/libqhullcpp/Coordinates.h
        src/libqhullcpp/functionObjects.h
        src/libqhullcpp/PointCoordinates.h
        src/libqhullcpp/Qhull.h
        src/libqhullcpp/QhullError.h
        src/libqhullcpp/QhullFacet.h
        src/libqhullcpp/QhullFacetList.h
        src/libqhullcpp/QhullFacetSet.h
        src/libqhullcpp/QhullHyperplane.h
        src/libqhullcpp/QhullIterator.h
        src/libqhullcpp/QhullLinkedList.h
        src/libqhullcpp/QhullPoint.h
        src/libqhullcpp/QhullPoints.h
        src/libqhullcpp/QhullPointSet.h
        src/libqhullcpp/QhullQh.h
        src/libqhullcpp/QhullRidge.h
        src/libqhullcpp/QhullSet.h
        src/libqhullcpp/QhullSets.h
        src/libqhullcpp/QhullStat.h
        src/libqhullcpp/QhullVertex.h
        src/libqhullcpp/QhullVertexSet.h
        src/libqhullcpp/RboxPoints.h
        src/libqhullcpp/RoadError.h
        src/libqhullcpp/RoadLogEvent.h
        src/libqhullcpp/UsingLibQhull.h
        src/qhulltest/RoadTest.h
)

set(
    libqhullcpp_SOURCES
        src/libqhullcpp/Coordinates.cpp
        src/libqhullcpp/PointCoordinates.cpp
        src/libqhullcpp/Qhull.cpp
        src/libqhullcpp/QhullFacet.cpp
        src/libqhullcpp/QhullFacetList.cpp
        src/libqhullcpp/QhullFacetSet.cpp
        src/libqhullcpp/QhullHyperplane.cpp
        src/libqhullcpp/QhullPoint.cpp
        src/libqhullcpp/QhullPointSet.cpp
        src/libqhullcpp/QhullPoints.cpp
        src/libqhullcpp/QhullQh.cpp
        src/libqhullcpp/QhullRidge.cpp
        src/libqhullcpp/QhullSet.cpp
        src/libqhullcpp/QhullStat.cpp
        src/libqhullcpp/QhullVertex.cpp
        src/libqhullcpp/QhullVertexSet.cpp
        src/libqhullcpp/RboxPoints.cpp
        src/libqhullcpp/RoadError.cpp
        src/libqhullcpp/RoadLogEvent.cpp
        src/libqhullcpp/UsingLibQhull.cpp
        ${libqhullcpp_HEADERS}
)

set(
    doc_FILES
        README.txt 
        REGISTER.txt 
        Announce.txt 
        COPYING.txt 
        index.htm
)

include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/libqhull)

if(CMAKE_BUILD_TYPE MATCHES "[dD]ebug")
    set(qhull_CPP qhullcpp_d)
    set(qhull_SHARED qhull_d)
    set(qhull_SHAREDP qhull_pd)
    set(qhull_STATIC qhullstatic_d)
    set(qhull_STATICP qhullstatic_pd)
else()
    set(qhull_CPP qhullcpp)
    set(qhull_SHARED libqhull)  # Avoid name conflict with qhull executable
    set(qhull_SHAREDP qhull_p)
    set(qhull_STATIC qhullstatic)
    set(qhull_STATICP qhullstatic_p)
endif()

set(
    qhull_TARGETS_INSTALL
        ${qhull_CPP} ${qhull_STATIC} ${qhull_STATICP} ${qhull_SHARED} ${qhull_SHAREDP}
        qhull rbox qconvex qdelaunay qvoronoi qhalf
)
set(
    qhull_TARGETS_TEST
        user_eg user_eg2 user_eg3 testqset
)
set(
    qhull_TARGETS
        ${qhull_TARGETS_INSTALL} ${qhull_TARGETS_TEST}
)


# ---------------------------------------
# Define shared library qhull without qh_QHpointer
# ---------------------------------------

add_library(${qhull_SHARED} SHARED 
        ${libqhull_SOURCES}
        src/libqhull/qhull-exports.def)
        
if(qhull_SHARED MATCHES "libqhull")
   set_target_properties(${qhull_SHARED} PROPERTIES
        OUTPUT_NAME "qhull")
endif()

set_target_properties(${qhull_SHARED} PROPERTIES
    SOVERSION ${qhull_SOVERSION})

if(UNIX)
    target_link_libraries(${qhull_SHARED} m)
    if(APPLE)
        set_target_properties(${qhull_SHARED} PROPERTIES 
            INSTALL_NAME_DIR "${LIB_INSTALL_DIR}")
    else()
        set_target_properties(${qhull_SHARED} PROPERTIES 
            INSTALL_RPATH "${LIB_INSTALL_DIR}"
            INSTALL_RPATH_USE_LINK_PATH TRUE
            BUILD_WITH_INSTALL_RPATH FALSE)
    endif()
endif(UNIX)

# ---------------------------------------
# Define shared library qhull with qh_QHpointer
# ---------------------------------------

add_library(${qhull_SHAREDP} SHARED 
        ${libqhull_SOURCES}
        src/libqhullp/qhull_p-exports.def)
set_target_properties(${qhull_SHAREDP} PROPERTIES
    COMPILE_DEFINITIONS "qh_QHpointer"
    SOVERSION ${qhull_SOVERSION})

if(UNIX)
    target_link_libraries(${qhull_SHAREDP} m)
    if(APPLE)
        set_target_properties(${qhull_SHAREDP} PROPERTIES 
            INSTALL_NAME_DIR "${LIB_INSTALL_DIR}")
    else()
        set_target_properties(${qhull_SHAREDP} PROPERTIES 
            INSTALL_RPATH "${LIB_INSTALL_DIR}"
            INSTALL_RPATH_USE_LINK_PATH TRUE
            BUILD_WITH_INSTALL_RPATH FALSE)
    endif()
endif(UNIX)

# ---------------------------------------
# Define static libraries qhullstatic and qhullstatic_p (qh_QHpointer)
# ---------------------------------------

add_library(${qhull_STATIC} STATIC ${libqhull_SOURCES})
set_target_properties(${qhull_STATIC} PROPERTIES
    VERSION ${qhull_VERSION})

add_library(${qhull_STATICP} STATIC ${libqhull_SOURCES})
set_target_properties(${qhull_STATICP} PROPERTIES
    COMPILE_DEFINITIONS "qh_QHpointer"
    VERSION ${qhull_VERSION})

if(UNIX)
    target_link_libraries(${qhull_STATIC} m)
    target_link_libraries(${qhull_STATICP} m)
endif(UNIX)

# ---------------------------------------
# Define C++ static library qhullcpp (qh_QHpointer)
# ---------------------------------------

add_library(${qhull_CPP} STATIC ${libqhullcpp_SOURCES})
set_target_properties(${qhull_CPP} PROPERTIES
    COMPILE_DEFINITIONS "qh_QHpointer"
    VERSION ${qhull_VERSION})

# ---------------------------------------
# Define qhull executables linked to qhullstatic library
# ---------------------------------------

set(qhull_SOURCES       src/qhull/unix.c)
set(rbox_SOURCES        src/rbox/rbox.c)
set(qconvex_SOURCES     src/qconvex/qconvex.c)
set(qdelaunay_SOURCES   src/qdelaunay/qdelaun.c)
set(qvoronoi_SOURCES    src/qvoronoi/qvoronoi.c)
set(qhalf_SOURCES       src/qhalf/qhalf.c)
set(user_eg2_SOURCES    src/user_eg2/user_eg2.c)
if(MSVC)
    set(user_eg_DEFINES qh_QHpointer qh_QHpointer_dllimport)
    set(user_eg2_DEFINES qh_dllimport)
else()
    set(user_eg_DEFINES qh_QHpointer)
    set(user_eg2_DEFINES )
endif()

add_executable(qhull ${qhull_SOURCES})
target_link_libraries(qhull ${qhull_STATIC})

add_executable(rbox ${rbox_SOURCES})
target_link_libraries(rbox ${qhull_STATIC})

add_executable(qconvex ${qconvex_SOURCES})
target_link_libraries(qconvex ${qhull_STATIC})

add_executable(qdelaunay ${qdelaunay_SOURCES})
target_link_libraries(qdelaunay ${qhull_STATIC})

add_executable(qvoronoi ${qvoronoi_SOURCES})
target_link_libraries(qvoronoi ${qhull_STATIC})

add_executable(qhalf ${qhalf_SOURCES})
target_link_libraries(qhalf ${qhull_STATIC})

# ---------------------------------------
# Define testqset linked to qset.o and mem.o
# ---------------------------------------

=== Makefile ===
# Unix Makefile for qhull and rbox (default gcc/g++)
#
#   see README.txt and 'make help'
#   For qhulltest, use Qt project file at src/qhull-all.pro
#   For static builds, an alternative is src/libqhull/Makefile
#   
# Results
#   qhull          Computes convex hull and related structures (libqhullstatic)
#   qconvex, qdelaunay, qhalf, qvoronoi
#                  Specializations of qhull for each geometric structure
#   libqhull.so    Shared library with a static qh_qh struct
#   libqhull_p.so  ... with a malloc'd qh_qh struct with -Dqh_QHpointer
#   make SO=dll    ... on Windows, use SO=dll.  It compiles dlls
#   libqhullstatic.a Static library with a static qh_qh struct
#                  ... called 'static' to avoid naming conflicts
#   libqhullstatic_p.a with a malloc'd qh_qh struct with -Dqh_QHpointer
#   libqhullcpp.a  Static library using a malloc'd qh_qh struct
#   user_eg        An example of using shared library qhull_p
#                  ... compiled with -Dqh_QHpointer
#   user_eg2       An example of using shared library qhull
#   user_eg3       An example of the C++ interface to qhull
#                  ... using libqhullcpp, libqhullstatic_p, -Dqh_QHpointer
#   testqset       Standalone test program for qset.c with mem.c
#
# Make targets
#   make           Produce all of the results
#   make qhullx    Produce qhull, qconvex etc. without using library
#   make qtest     Quick test of rbox and qhull (bin/rbox D4 | bin/qhull)
#   make qtestall  Quick test of all programs except qhulltest
#   make test      Test of rbox and qhull
#   make bin/qvoronoi  Produce bin/qvoronoi (etc.)
#   make doc       Print documentation
#   make install   Copy qhull, rbox, qhull.1, rbox.1 to BINDIR, MANDIR
#   make new       Rebuild qhull and rbox from source
#
#   make printall  Print all files
#   make clean     Remove object files
#   make cleanall  Remove generated files
#
#   DESTDIR        destination directory. Other directories are relative
#   BINDIR         directory where to copy executables
#   DOCDIR         directory where to copy html documentation
#   INCDIR         directory where to copy headers
#   LIBDIR         directory where to copy libraries
#   MANDIR         directory where to copy manual pages
#   PRINTMAN       command for printing manual pages
#   PRINTC         command for printing C files
#   CC             ANSI C or C++ compiler
#   CC_OPTS1       options used to compile .c files
#   CC_OPTS2       options used to link .o files
#   CC_OPTS3       options to build shared libraries
#   CXX            ANSI C++ compiler
#   CXX_OPTS1      options used to compile .cpp files
#   CXX_OPTS2      options used to link .o files
#   CC_WARNINGS    warnings for .c programs
#   CXX_WARNINGS   warnings for .cpp programs
#
#   LIBQHULLS_OBJS .o files for linking
#   LIBQHULL_HDRS  .h files for printing
#   CFILES         .c files for printing
#   CXXFILES       .cpp files for printing
#   TESTFILES      .cpp test files for printing
#   DOCFILES       documentation files
#   FILES          miscellaneous files for printing
#   HTMFILES       documentation source files
#   TFILES         .txt versions of html files
#   FILES          all other files
#   LIBQHULLS_OBJS specifies the object files of libqhullstatic.a
#
# Do not replace tabs with spaces.  Needed by 'make' for build rules

# You may build the qhull programs without using a library
# make qhullx

DESTDIR = /usr/local
BINDIR	= $(DESTDIR)/bin
INCDIR	= $(DESTDIR)/include
LIBDIR	= $(DESTDIR)/lib
DOCDIR	= $(DESTDIR)/share/doc/qhull
MANDIR	= $(DESTDIR)/share/man/man1

# if you do not have enscript, try a2ps or just use lpr.  The files are text.
PRINTMAN = enscript -2rl
PRINTC = enscript -2r
# PRINTMAN = lpr
# PRINTC = lpr

#for Gnu's gcc compiler, -O2 for optimization, -g for debugging
CC        = gcc
CC_OPTS1  = -O2 -fPIC -ansi -Isrc/libqhull $(CC_WARNINGS)
CXX       = g++

# libqhullcpp must be before libqhull
CXX_OPTS1 = -O2 -Dqh_QHpointer -Isrc/ -Isrc/libqhullcpp -Isrc/libqhull $(CXX_WARNINGS)

# for shared library link
CC_OPTS3  =

# Define qhull_VERSION in CMakeLists.txt, Makefile, and qhull-warn.pri
# Truncated version in qhull-exports.def, qhull_p-exports.def, 
#  qhull.so -- static qh_qhT global data structure (qh_QHpointer=0)
#  qhull_p.so -- allocated qh_qhT global data structure (qh_QHpointer=1).  Required for libqhullcpp
#  qhull_m.so -- future version of Qhull with qh_qhT passed as an argument.
qhull_SOVERSION=6
SO  = so.6.3.1

# On MinGW, 
#   make SO=dll
#   Copy lib/libqhull6_p.dll and lib/libqhull.dll to bin/

# for Sun's cc compiler, -fast or O2 for optimization, -g for debugging, -Xc for ANSI
#CC       = cc
#CC_OPTS1 = -Xc -v -fast

# for Silicon Graphics cc compiler, -O2 for optimization, -g for debugging
#CC       = cc
#CC_OPTS1 = -ansi -O2

# for Next cc compiler with fat executable
#CC       = cc
#CC_OPTS1 = -ansi -O2 -arch m68k -arch i386 -arch hppa

# For loader, ld, 
CC_OPTS2 = $(CC_OPTS1)
CXX_OPTS2 = $(CXX_OPTS1)

# [gcc 4.4] Compiles without error (-Werror)
CC_WARNINGS  = -Wall -Wcast-qual -Wextra -Wwrite-strings -Wshadow
CXX_WARNINGS = -Wall -Wcast-qual -Wextra -Wwrite-strings -Wno-sign-conversion -Wshadow -Wconversion 

# Compiles OK with all gcc warnings except for -Wno-sign-conversion and -Wconversion
# Compiles OK with all g++ warnings except Qt source errors on -Wshadow and -Wconversion
#    -Waddress -Warray-bounds -Wchar-subscripts -Wclobbered -Wcomment -Wunused-variable
#    -Wempty-body -Wformat -Wignored-qualifiers -Wimplicit-function-declaration -Wimplicit-int
#    -Wmain -Wmissing-braces -Wmissing-field-initializers -Wmissing-parameter-type -Wnonnull
#    -Wold-style-declaration -Woverride-init -Wparentheses -Wpointer-sign -Wreturn-type
#    -Wsequence-point -Wsign-compare -Wsign-compare -Wstrict-aliasing -Wstrict-overflow=1
#    -Wswitch -Wtrigraphs -Wtype-limits -Wuninitialized -Wuninitialized -Wvolatile-register-var
#    -Wunknown-pragmas -Wunused-function -Wunused-label -Wunused-parameter -Wunused-value

# Default targets for make
     
all: bin-lib bin/rbox bin/qconvex bin/qdelaunay bin/qhalf bin/qvoronoi \
     bin/qhull bin/testqset qtest bin/user_eg2 bin/user_eg3 bin/user_eg qconvex-prompt

help:
	head -n 50 Makefile

bin-lib:
	mkdir -p bin lib
     
# Remove intermediate files for all builds
clean:
	rm -f src/*/*.o src/qhulltest/RoadTest.h.cpp build/*/*/*.o  build/*/*.o
	rm -f src/*/*.obj build/*/*/*.obj build/*/*/*/*/*.obj build/*/*.obj 
	rm -f bin/*.idb lib/*.idb build-cmake/*/*.idb 
	rm -f build/*/*/*.a build/*/*/*.rsp build/moc/*.moc
	rm -f build-cmake/*/*.obj build-cmake/*/*/*.obj build-cmake/*/*.ilk

# Remove intermediate files and targets for all builds
cleanall: clean
	rm -f bin/qconvex bin/qdelaunay bin/qhalf bin/qvoronoi bin/qhull
	rm -f core bin/core bin/user_eg bin/user_eg2 bin/user_eg3
	rm -f lib/libqhull* lib/qhull*.lib lib/qhull*.exp  lib/qhull*.dll
	rm -f bin/libqhull* bin/qhull*.dll bin/*.exe bin/*.pdb lib/*.pdb
	rm -f build/*.dll build/*.exe build/*.a build/*.exp 
	rm -f build/*.lib build/*.pdb build/*.idb
	rm -f build-cmake/*/*.dll build-cmake/*/*.exe build-cmake/*/*.exp 
	rm -f build-cmake/*/*.lib build-cmake/*/*.pdb

doc: 
	$(PRINTMAN) $(TXTFILES) $(DOCFILES)

install:
	mkdir -p $(BINDIR)
	mkdir -p $(DOCDIR)
	mkdir -p $(INCDIR)/libqhull
	mkdir -p $(INCDIR)/libqhullcpp
	mkdir -p $(LIBDIR)
	mkdir -p $(MANDIR)
	cp bin/qconvex $(BINDIR)
	cp bin/qdelaunay $(BINDIR)
	cp bin/qhalf $(BINDIR)
	cp bin/qhull $(BINDIR)
	cp bin/qvoronoi $(BINDIR)
	cp bin/rbox $(BINDIR)
	cp html/qhull.man $(MANDIR)/qhull.1
	cp html/rbox.man $(MANDIR)/rbox.1
	cp html/* $(DOCDIR)
	cp -P lib/* $(LIBDIR)
	cp src/libqhull/*.h src/libqhull/*.htm $(INCDIR)/libqhull
	cp src/libqhullcpp/*.h $(INCDIR)/libqhullcpp
	cp src/qhulltest/*.h $(INCDIR)/libqhullcpp

new:	cleanall all

printall: doc printh printc printf

printh:
	$(PRINTC) $(LIBQHULL_HDRS)
	$(PRINTC) $(LIBQHULLCPP_HDRS)

printc:
	$(PRINTC) $(CFILES)
	$(PRINTC) $(CXXFILES)
	$(PRINTC) $(TESTFILES)

printf:
	$(PRINTC) $(FILES)

qtest:
	@echo ==============================
	@echo == Test qset.c with mem.c ====
	@echo ==============================
	-bin/testqset 10000
	@echo ==============================
	@echo == Run the qhull smoketest ===
	@echo ==============================
	-bin/rbox D4 | bin/qhull Tv
	
qtestall:  qtest
	@echo ==============================
	@echo ========= qconvex ============
	@echo ==============================
	-bin/rbox 10 | bin/qconvex Tv 
	@echo ==============================
	@echo ========= qdelaunay ==========
	@echo ==============================
	-bin/rbox 10 | bin/qdelaunay Tv 
	@echo ==============================
	@echo ========= qhalf ==============
	@echo ==============================
	-bin/rbox 10 | bin/qconvex FQ FV n Tv | bin/qhalf Tv
	@echo ==============================
	@echo ========= qvoronoi ===========
	@echo ==============================
	-bin/rbox 10 | bin/qvoronoi Tv
	@echo ==============================
	@echo ========= user_eg ============
	@echo ==============================
	-bin/user_eg
	@echo ==============================
	@echo ========= user_eg2 ===========
	@echo ==============================
	-bin/user_eg2
	@echo ==============================
	@echo ========= user_eg3 ===========
	@echo ==============================
	-bin/user_eg3 rbox "10 D2"  "2 D2" qhull "s p" facets

test:
	-eg/q_eg
	-eg/q_egtest
	-eg/q_test

qconvex-prompt:
	-bin/qconvex
	@echo '== For libqhull.so and libqhull_p.so'
	@echo '   export LD_LIBRARY_PATH=$$PWD/lib:$$LD_LIBRARY_PATH'
	@echo
	@echo '== For libqhull.dll and libqhull_p.dll'
	@echo '   cp lib/libqhull*.dll bin'
	@echo
	@echo '== The previous steps are required for user_eg and user_eg2'
	@echo
	@echo '== To smoketest each program'
	@echo '   make qtestall'
	@echo

L=    src/libqhull
LS=   src/libqhullstatic
LSP=  src/libqhullstaticp
LCPP= src/libqhullcpp
TCPP= src/qhulltest

LIBQHULL_HDRS = $(L)/user.h $(L)/libqhull.h $(L)/qhull_a.h $(L)/geom.h \
        $(L)/io.h $(L)/mem.h $(L)/merge.h $(L)/poly.h $(L)/random.h \
        $(L)/qset.h $(L)/stat.h

# LIBQHULLS_OBJS_1 and LIBQHULLSP_OBJS ordered by frequency of execution with 
# small files at end.  Better locality.

LIBQHULLS_OBJS_1= $(LS)/global.o $(LS)/stat.o $(LS)/geom2.o $(LS)/poly2.o \
        $(LS)/merge.o $(LS)/libqhull.o $(LS)/geom.o $(LS)/poly.o \
        $(LS)/qset.o $(LS)/mem.o $(LS)/random.o 

LIBQHULLS_OBJS_2 = $(LIBQHULLS_OBJS_1) $(LS)/usermem.o $(LS)/userprintf.o \
        $(LS)/io.o $(LS)/user.o

LIBQHULLS_OBJS = $(LIBQHULLS_OBJS_2) $(LS)/rboxlib.o $(LS)/userprintf_rbox.o 

LIBQHULLSP_OBJS = $(LSP)/global.o $(LSP)/stat.o \
        $(LSP)/geom2.o $(LSP)/poly2.o $(LSP)/merge.o \
        $(LSP)/libqhull.o $(LSP)/geom.o $(LSP)/poly.o $(LSP)/qset.o \
        $(LSP)/mem.o $(LSP)/random.o $(LSP)/usermem.o $(LSP)/userprintf.o \
	$(LSP)/io.o $(LSP)/user.o $(LSP)/rboxlib.o $(LSP)/userprintf_rbox.o

LIBQHULLCPP_HDRS = $(LCPP)/RoadError.h $(LCPP)/RoadLogEvent.h $(LCPP)/Coordinates.h \
	$(LCPP)/QhullHyperplane.h $(LCPP)/functionObjects.h $(LCPP)/PointCoordinates.h \
	$(LCPP)/Qhull.h $(LCPP)/QhullError.h $(LCPP)/QhullFacet.h \
	$(LCPP)/QhullFacetList.h $(LCPP)/QhullFacetSet.h $(LCPP)/QhullIterator.h \
	$(LCPP)/QhullLinkedList.h $(LCPP)/QhullPoint.h $(LCPP)/QhullPoints.h \
	$(LCPP)/QhullPointSet.h $(LCPP)/QhullQh.h $(LCPP)/QhullRidge.h \
	$(LCPP)/QhullSet.h $(LCPP)/QhullSets.h $(LCPP)/QhullStat.h \
	$(LCPP)/QhullVertex.h $(LCPP)/RboxPoints.h $(LCPP)/UsingLibQhull.h
       
LIBQHULLCPP_OBJS = $(LCPP)/RoadError.o $(LCPP)/RoadLogEvent.o $(LCPP)/Coordinates.o \
	$(LCPP)/PointCoordinates.o $(LCPP)/Qhull.o $(LCPP)/QhullFacet.o \
	$(LCPP)/QhullFacetList.o $(LCPP)/QhullFacetSet.o \
	$(LCPP)/QhullHyperplane.o $(LCPP)/QhullPoint.o \
	$(LCPP)/QhullPoints.o $(LCPP)/QhullPointSet.o $(LCPP)/QhullQh.o \
	$(LCPP)/QhullRidge.o $(LCPP)/QhullSet.o $(LCPP)/QhullStat.o \
	$(LCPP)/QhullVertex.o $(LCPP)/QhullVertexSet.o $(LCPP)/RboxPoints.o \
	$(LCPP)/UsingLibQhull.o src/user_eg3/user_eg3.o

## qhull 2009.1

=== debian/changelog ===
qhull (2009.1-3) unstable; urgency=low

  * Team upload.
  * Add fix-FTBFS-643461-format-security.patch patch.
    Fix format-security compiler warnings.
    Thanks to peter green <plugwash@p10link.net> for the patch (Closes: #643461)
  * Drop quilt framework.
    Explicit dependencies on quilt is not needed as we use '3.0 (quilt)'
    source package format.

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 23 Nov 2011 09:03:46 +0100

qhull (2009.1-2) unstable; urgency=low

  * Team upload
  * Standards-Version updated to 3.9.2
  * Switch to dpkg-source 3.0 (quilt) format
  * Package moved into the debian science team
  * Fix the FTBFS with binutils-gold. Thanks to Iain Lane for providing the
    patch (Closes: #556302)
  * .la file is no longer installed

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Aug 2011 09:50:39 +0200

qhull (2009.1-1) unstable; urgency=low

  * New upstream release
  * debian/patches/modern-autotools.patch: Drop patch (this new upstream
    release was generated with modern versions of the Autotools)
  * debian/patches/manpage-macros.patch: Drop patch (applied upstream)
  * debian/source.lintian-overrides: Drop obsolete override for Lintian
    warning ancient-libtool
  * debian/rules:
    + Use DEB_MAKE_CHECK_TARGET to run the unit tests through the check
      rule in debian/rules
    + Avoid running twice the build/qhull-bin rule (via a build-stamp
      file)
  * debian/clean: Remove build-stamp
  * debian/watch: Fix URL and regex for upstream tarball

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 14 Jun 2009 16:46:41 +0200

qhull (2003.1-12) unstable; urgency=low

  * debian/patches/modern-autotools.patch: Jumbo patch for updating the
    autotools-generated files with modern ones
  * debian/source.lintian-overrides:
    + Drop obsolete Lintian overrides outdated-autotools-helper-file
    + Add override for ancient-libtool, since file config/ltmain.sh is
      replaced by a modern one in the patch above
  * debian/control:
    + The Debian packaging files are now maintained through a Git
      repository at alioth.debian.org.  Switch the Vcs-* URLs to Git,
      accordingly.
    + Bump Standards-Version to 3.8.1 (add file README.source explaining
      the quilt patchsys, as mandated by the Policy)
    + Add ${misc:Depends} to all packages
    + Drop Section field of the qhull-bin package, which is redundant with
      the Section of the Source package
    + Build-Depend on autotools-dev, this is necessary for proper
      treatment of files config.{guess,sub} by CDBS
  * Add descriptions to all patches
  * debian/libqhull5.symbols: Add shared library symbols file
  * debian/libqhull-doc.lintian-overrides: Add comment

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 30 Apr 2009 13:08:22 +0200

qhull (2003.1-11) unstable; urgency=low

  * debian/rules: Use debian/clean instead of manually cleaning files
  * debian/compat, debian/control: Bump build-dependency on debhelper to
    >= 7.0.0, otherwise debian/clean is moot
  * debian/clean: New file

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 14 Aug 2008 13:26:11 +0200

qhull (2003.1-9lenny1) testing-proposed-updates; urgency=low

  * debian/rules: Use sed instead of eperl to generate the man pages.
    Eperl is buggy on hppa (see Bug#494191) and the package FTBFS there.
    (Closes: #494461)
  * debian/manpage.in: Adapt for using sed
  * debian.control:
    + Drop build-dependency on eperl
    + Build-depends on docbook-xml.  This avoid timeouts due to the failed
    attempt to load the external entity docbookx.dtd (needed for the
    Debian-provided man pages) when network connection is not available.
    + Bump Standards-Version to 3.8.0 (no changes needed)

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 14 Aug 2008 10:43:24 +0200

qhull (2003.1-10lenny1) unstable; urgency=low

  * debian/control: Build-depends on docbook-xml.  This avoid FTBFS due to
    the failed attempt to load the external entity docbookx.dtd (needed for
    the Debian-provided man pages) when network connection is not available
    (closes: #493456).

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 02 Aug 2008 22:00:22 +0200

qhull (2003.1-10) unstable; urgency=low

  * Create new package libqhull-doc containing the HTML documentation for
    Qhull.  This avoids a Lintian message saying that the arch-dependent
    package libqhull-dev has a big /usr/share directory.
  * debian/copyright: Clarify licensing conditions for the Debian
    packaging files
  * Bump Standards-Version to 3.8.0 (no changes needed)

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 27 Jun 2008 19:30:35 +0200

qhull (2003.1-9) unstable; urgency=low

  * debian/manpage.in:
    + Fix spacing in <ulink> tag
    + Remove brackets from email address
  * debian/README.Debian: Fixed path of documentation and examples files.
    Also, mention that these files are available in the libqhull-dev
    package.  Thanks to Jaap Weel for pointing this bug out.
  * debian/rules: Switch from CDBS' simple-patchsys to quilt
  * debian/control:
    + Build-depend on quilt
    + Fix URL of Vcs-Svn field
    + Add ${shlibs:Depends} to qhull-bin Depends
  * debian/libqhull-dev.doc-base: Changed section of documentation to
    Science/Mathematics
  * debian/patches/manpage-macros.patch: Add patch for fixing several
    syntax, macros, and hyphen problems in man pages qhull.man and rbox.man

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 19 Apr 2008 20:37:42 +0200

qhull (2003.1-8) unstable; urgency=low

  * debian/control:
    + Use the substitution variable ${binary:Version} instead of the
      deprecated ${Source-Version}
    + Added Homepage field
    + Use the now official Vcs-* fields instead of the obsolete XS-Vcs-*
    + Dropped the Homepage pseudo-header for the extended descriptions
    + Bumped Standards-Version to 3.7.3
  * debian/rules:
    + Include the -fno-strict-aliasing option into CFLAGS, otherwise the


=== debian/control ===
Source: qhull
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rafael Laboissiere <rafael@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7.0.0), docbook2x (>= 0.8.8-3), xsltproc,
 cdbs, docbook-xml, autotools-dev
Homepage: http://www.qhull.org
Vcs-Git: git://anonscm.debian.org/debian-science/packages/qhull.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/qhull.git

Package: libqhull5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: calculate convex hulls and related structures (shared library)
 Qhull computes convex hulls, Delaunay triangulations, halfspace
 intersections about a point, Voronoi diagrams, furthest-site
 Delaunay triangulations, and furthest-site Voronoi diagrams. It
 runs in 2-d, 3-d, 4-d, and higher dimensions.
 .
 This package contains the shared C library.

Package: libqhull-dev
Section: libdevel
Architecture: any
Depends: libqhull5 (= ${binary:Version}), ${misc:Depends}
Description: calculate convex hulls and related structures (development files)
 Qhull computes convex hulls, Delaunay triangulations, halfspace
 intersections about a point, Voronoi diagrams, furthest-site
 Delaunay triangulations, and furthest-site Voronoi diagrams. It
 runs in 2-d, 3-d, 4-d, and higher dimensions.
 .
 This package contains the files necessary for development (headers and
 libraries), as well as the library documentation in HTML format.

Package: libqhull-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: calculate convex hulls and related structures (documentation files)
 Qhull computes convex hulls, Delaunay triangulations, halfspace
 intersections about a point, Voronoi diagrams, furthest-site
 Delaunay triangulations, and furthest-site Voronoi diagrams. It
 runs in 2-d, 3-d, 4-d, and higher dimensions.
 .
 This package contains the documentation for Qhull.

Package: qhull-bin
Architecture: any
Depends: libqhull5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: geomview
Description: calculate convex hulls and related structures (utilities)
 Qhull computes convex hulls, Delaunay triangulations, halfspace
 intersections about a point, Voronoi diagrams, furthest-site
 Delaunay triangulations, and furthest-site Voronoi diagrams. It
 runs in 2-d, 3-d, 4-d, and higher dimensions.
 .
 This package contains the qhull executable that gives a pipe interface to
 some of the functionality of the library.  Also included is rbox is a
 useful tool in generating input for Qhull; it generates hypercubes,
 diamonds, cones, circles, simplices, spirals, lattices, and random points.
 .
 Qhull produces graphical output for Geomview.  This helps with
 understanding the output (http://www.geomview.org).

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Debian qhull package
# GNU copyright (C) 2007, 2008  Rafael Laboissiere

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

debdir	:= $(CURDIR)/debian
htmldir	:= $(debdir)/tmp/usr/share/doc/qhull/html

DEB_DH_INSTALL_SOURCEDIR = debian/tmp
DEB_COMPRESS_EXCLUDE = .c .h .txt
CFLAGS := $(CFLAGS) -fno-strict-aliasing
DEB_MAKE_CHECK_TARGET = -C debian -f rules check

build/qhull-bin:: build-stamp
build-stamp:
	# Build man pages
	@( cd debian ;							\
	  for info in "qconvex:compute the convex hull"			\
	              "qdelaunay:compute the Delaunay triangulation"	\
	              "qhalf:halfspace intersection about a point"	\
	              "qvoronoi:compute the Voronoi diagram" ; do	\
	      comm=`echo  $$info | cut -d: -f1` ;			\
	      purp=`echo  $$info | cut -d: -f2` ;			\
	      echo -n Building man page for $$comm... ;			\
	      sed "s/#command#/$$comm/;s/#purpose#/$$purp/"		\
	          manpage.in > $$comm.xml ;				\
	      docbook2x-man $$comm.xml ;				\
	      echo " done" ;						\
	  done )
	touch build-stamp

check:
	# Run tests
	cd .. ; PATH=./src/:$$PATH /bin/sh eg/q_test

install/libqhull-doc::
	# Install all the needed documentation files
	cp *.txt html/*.txt $(htmldir)
	mkdir $(htmldir)/src
	cp src/*.c src/*.h src/*.htm src/*.txt $(htmldir)/src
	sed -i 's:href="../:href=":g' $(htmldir)/*.htm

=== debian/watch ===
version=3
https://savannah.nongnu.org/files/?group=qhull qhull-([\d+\.]+)\.tar\.gz

## qhull 2012.1

=== debian/changelog ===
qhull (2012.1-4) unstable; urgency=medium

  * Add convenience link to #include <qhull/qhull.h> to simplify transition.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 13 Feb 2014 11:09:12 +0000

qhull (2012.1-3) unstable; urgency=medium

  * Simplify man page patch.
  * Support multi-arch.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 13 Feb 2014 08:54:29 +0000

qhull (2012.1-2) unstable; urgency=medium

  * Build dependency on cmake is needed.
  * Remove ancient install-time scripts related to /usr/doc/ transition.
  * Create backwards-compatibility links in /usr/include/qhull/.

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 08 Feb 2014 22:45:45 +0000

qhull (2012.1-1) unstable; urgency=low

  * New upstream release (closes: #621909)
    - Port quilt patches to new upstream.
    - Upstream now supports cmake: use it instead of autotools.
      - This should address the binutils-gold issue (closes: #556302)
      - Ditto for undefined reference to pow@@GLIBC_2.2.5 (closes: #713546)
    - Upstream incremented to libqhull.so.6 so switch to libqhull6
      - Remove symbols file
    - Update many paths to account for upstream changes.
      - upstream installs .htm files intermingled with .h file in /usr/include,
        move the .htm to /usr/share/doc with symlinks for the .h files as they
        are referred to from the .htm files.  (These will be missing if the -doc
        package is installed without the -dev package, but it hardly seems worth
        adding a dependency.)
  * Add myself as uploader in debian/control (closes: #571875)
  * Fix wx include __POWERPC__ issue (closes: #640432)
  * Update/modify debian packaging
    - Switch to dh9 in debian/rules; flush cdbs.
    - Bump standards version
    - Various simplifications allowed by modern dh.
    - Move all dev docs to -doc; remove contrary stanza in README.Debian.
    - Activate single-debian-patch source option; see git for patch breakdown.
    - Gentler preinst /usr/share/doc/libqhull-dev symlink excision, and add
      preinst to similarly excise any /usr/share/doc/qhull-bin symlink.
    - Mash installed debian/tmp into shape ourselves.
  * Add quilt patches for minor issues: spelling, man page bug
  * Put Debian TODO file in -doc package

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 06 Feb 2014 13:43:21 +0000

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,22 @@
 Section: math
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Rafael Laboissiere <rafael@debian.org>
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 7.0.0), docbook2x (>= 0.8.8-3), xsltproc,
- cdbs, docbook-xml, autotools-dev
+Uploaders: Barak A. Pearlmutter <bap@debian.org>
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9),
+	       dh-exec (>= 0.3),
+	       cmake,
+	       chrpath,
+	       docbook2x (>= 0.8.8-3), xsltproc, docbook-xml
 Homepage: http://www.qhull.org
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/qhull.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/qhull.git
 
-Package: libqhull5
+Package: libqhull6
 Section: libs
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: calculate convex hulls and related structures (shared library)
  Qhull computes convex hulls, Delaunay triangulations, halfspace
@@ -25,7 +30,9 @@
 Package: libqhull-dev
 Section: libdevel
 Architecture: any
-Depends: libqhull5 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: libqhull6 (= ${binary:Version}), ${misc:Depends}
 Description: calculate convex hulls and related structures (development files)
  Qhull computes convex hulls, Delaunay triangulations, halfspace
  intersections about a point, Voronoi diagrams, furthest-site
@@ -49,7 +56,7 @@
 
 Package: qhull-bin
 Architecture: any
-Depends: libqhull5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libqhull6 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Suggests: geomview
 Description: calculate convex hulls and related structures (utilities)
  Qhull computes convex hulls, Delaunay triangulations, halfspace

=== debian/watch ===
version=3
# https://savannah.nongnu.org/files/?group=qhull qhull-([\d+\.]+)\.tar\.gz
http://www.qhull.org/download/qhull-(\d[\d\.]*)-src\.tgz
# http://www.qhull.org/download/qhull-(\d[\d\.]*)\.tar\.gz
